<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:rich="http://richfaces.org/rich"
                xmlns:g="http://www.ihe.net/gazelle"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:param name="pageNameTitle" value="#{messages['gazelle.tf.menu.Standards']}"/>
    <ui:define name="body">
        <h:form id="globalform" styleClass="form-horizontal">
            <s:token allowMultiplePosts="true"/>
            <s:decorate template="/tf/standard/suggestFilters.xhtml">
                <ui:param name="managedBean" value="#{standardManager}"/>
                <ui:define name="otherButtons">
                    <h:outputLink value="edit.seam" styleClass="gzl-btn-green"
                                  rendered="#{( s:hasRole('admin_role') || s:hasRole('tests_editor_role')) and applicationManager.isMasterModel()}">
                        <h:outputText value="#{messages['net.ihe.gazelle.tm.NewStandard']}"/>
                    </h:outputLink>

                    <h:commandLink title="#{messages['net.ihe.gazelle.tm.DownloadFilteredStandardsAsXmlFile']}"
                                   ignoreDupResponses="true"
                                   action="#{standardManager.exportStandardsAsXml()}"
                                   rendered="#{s:hasRole('admin_role')}"
                                   value ="#{messages['net.ihe.gazelle.tm.ExportFilteredStandards']}"
                                   styleClass="gzl-btn-blue pull-right"
                                   execute="@this"/>
                </ui:define>
            </s:decorate>
            <s:decorate template="/tf/standard/standardTable.xhtml">
                <ui:param name="standards" value="#{standardManager.standards}"/>
                <ui:define name="actions">
                    <div class="gzl-never-wrap">
                        <h:outputLink value="show.seam" title="#{messages['gazelle.common.button.View']}">
                            <f:param name="keyword" value="#{std.keyword}"/>
                            <span class="gzl-icon-search"/>
                        </h:outputLink>
                        <h:outputLink title="#{messages['gazelle.tm.Edit']}" value="edit.seam"
                                      rendered="#{( s:hasRole('admin_role') || s:hasRole('tests_editor_role')) and applicationManager.isMasterModel()}">
                            <f:param name="keyword" value="#{std.keyword}"/>
                            <span class="gzl-icon-pencil"/>
                        </h:outputLink>
                        <a4j:commandLink event="click"
                                         oncomplete="jq162('#DeleteConfirmationModalPanel').modal('show');"
                                         title="#{messages['gazelle.common.button.Delete']}"
                                         rendered="#{( s:hasRole('admin_role') || s:hasRole('tests_editor_role')) and applicationManager.isMasterModel()}"
                                         render="DeleteConfirmationModalPanel,globalform, :deleteDocumentForm"
                                         execute="@this"
                                         actionListener="#{standardManager.setSelectedStandard(std)}">
                            <span class="gzl-icon-trash-o"/>
                        </a4j:commandLink>
                    </div>
                </ui:define>
            </s:decorate>

            <s:div id ="importDiv" rendered="#{(s:hasRole('admin_role'))}">
                <ui:decorate template="/layout/panels/_panel_title_footer_id.xhtml">

                    <ui:param name="panel_id" value="importPanel"/>
                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.tm.ImportStandards']}"/>
                    </ui:define>

                    <s:div id="uploadFile" rendered="#{standardManager.standardsToImport == null}">
                        <s:div rendered="#{standardManager.getUploadedFileContent() == null}">
                            <h:outputText id="fileUploadInfo"
                                          value="#{messages['net.ihe.gazelle.tm.PleaseUploadTheXMLFileContainingStandardsToImpor']}"/>
                            <ul>
                                <li>
                                    <h:outputText value="#{messages['net.ihe.gazelle.tm.TransactionDetectionIsBasedOnKeywordsIfOneDoesNo']}"/>
                                </li>
                                <li>
                                    <h:outputText value="#{messages['net.ihe.gazelle.tm.TheImportedStandardWillBeLinkedToAllTransactionF']}"/>
                                </li>
                            </ul>
                            <rich:fileUpload
                                    fileUploadListener="#{standardManager.uploadListener}"
                                    maxFilesQuantity="1"
                                    listHeight="60px"
                                    immediateUpload="true">
                                <a4j:ajax event="uploadcomplete" render="uploadFile, footer"/>
                            </rich:fileUpload>
                        </s:div>

                        <s:div id="fileNameInfo" rendered="#{standardManager.getUploadedFileContent() != null}" styleClass="form-horizontal">

                            <s:decorate template="/layout/display/_data_list_item.xhtml">
                                <ui:define name="label">
                                    <h:outputText  value="#{messages['net.ihe.gazelle.tm.StandardsFile']}"/>
                                </ui:define>
                                <h:outputText value="#{standardManager.getDescription()}"  />
                            </s:decorate>

                        </s:div>

                        <s:div id="reviewDiv">
                            <s:decorate template="/layout/form/_checkbox.xhtml">
                                <ui:param name="id" value="cbAutoImport"/>
                                <ui:define name="label">
                                    <h:outputText  value="#{messages['net.ihe.gazelle.tm.ReviewChangesBeforeSaving']}"/>
                                </ui:define>
                                <h:selectBooleanCheckbox id="cbAutoImport" value="#{standardManager.reviewBeforeSaving}">
                                    <a4j:ajax event="change" render="reviewDiv"/>
                                </h:selectBooleanCheckbox>
                            </s:decorate>

                            <s:div rendered="#{not standardManager.reviewBeforeSaving}">
                                <br/>
                                <s:span styleClass="gzl-icon-exclamation-triangle"/>
                                <h:outputText id="cbAutoImport"
                                              class="gzl-text-orange"
                                              value="#{messages['net.ihe.gazelle.tm.TheImportedStandardsWillBePersistedInDatabaseWit']}"/>
                            </s:div>
                        </s:div>

                    </s:div>

                    <s:div id="reportDiv" rendered="#{standardManager.standardsToImport != null}" >
                        <ui:decorate template="/layout/panels/_panel_title_footer_id.xhtml">

                            <ui:param name="panel_id" value="reportPanel"/>
                            <ui:define name="panel_title">
                                <h:outputText value="#{messages['net.ihe.gazelle.tm.ReportOnStandardsImport']}"/>
                            </ui:define>

                            <s:div id="reportBody" rendered="#{standardManager.standardsToImport != null}" >
                                <div class="panel-body bg-primary">
                                    <s:div rendered="#{standardManager.standardsToImport.unknownTransaction != null}">
                                        <h:outputText value="#{standardManager.standardsToImport.unknownTransaction.size} #{messages['net.ihe.gazelle.tm.TransactionsHaveBeenFoundMissingInThisInstance']}" style="font-weight:bold"/>
                                        <br/>
                                        <s:div rendered="#{not standardManager.standardsToImport.unknownTransaction.isEmpty()}">
                                            <h:outputText value="#{messages['net.ihe.gazelle.tm.HereIsTheListOfTransactionsThatHaveBeenIgnored']} "/>
                                            <ul>
                                                <ui:repeat value="#{standardManager.standardsToImport.unknownTransaction}" var="transaction">
                                                    <li>
                                                        <h:outputText value="#{transaction}"/>
                                                    </li>
                                                </ui:repeat>
                                            </ul>
                                        </s:div>
                                    </s:div>
                                </div>
                                <br/>
                                <s:div rendered="#{standardManager.standardsToImport.standards != null and rulesManager.reviewBeforeSaving}">
                                    <h:outputText value="#{standardManager.standardsToImport.standards.size} #{messages['net.ihe.gazelle.tm.StandardsWillBeImportedIntoYourDatabase']}" style="font-weight:bold"/>
                                </s:div>
                                <s:div rendered="#{standardManager.standardsToImport.standards != null and not rulesManager.reviewBeforeSaving}">
                                    <h:outputText value="#{standardManager.standardsToImport.standards.size} #{messages['net.ihe.gazelle.tm.StandardsHaveBeenImportedIntoYourDatabase']}" style="font-weight:bold"/>
                                </s:div>

                                <s:div rendered="#{not (standardManager.standardsToImport.standards == null) and not standardManager.standardsToImport.standards.isEmpty()}">
                                    <div class="panel-body">
                                        <rich:dataTable id="standardToImportTable" var="std" value="#{standardManager.standardsToImport.standards}"
                                                        rowKeyVar="rowNumber" rows="#{dataScrollerMemory.numberOfResultsPerPage}" render="dsImport">
                                            <g:column sortBy="#{'keyword'}">
                                                <ui:define name="header">
                                                    <h:outputText value="#{messages['gazelle.testmanagement.object.keyword']}"/>
                                                </ui:define>
                                                <h:outputText value="#{std.keyword}"/>
                                            </g:column>
                                            <g:column sortBy="#{'name'}">
                                                <ui:define name="header">
                                                    <h:outputText value="#{messages['gazelle.testmanagement.object.Name']}"/>
                                                </ui:define>
                                                <h:outputLink value="#{std.url}">
                                                    <h:outputText value="#{std.name}"/>
                                                </h:outputLink>
                                            </g:column>
                                            <g:column sortBy="#{'version'}">
                                                <ui:define name="header">
                                                    <h:outputText value="#{messages['gazelle.systems.system.SystemVersion']}"/>
                                                </ui:define>
                                                <h:outputText value="#{std.version}"/>
                                            </g:column>
                                            <g:column sortBy="#{'networkCommunicationType'}">
                                                <ui:define name="header">
                                                    <h:outputText value="#{messages['net.ihe.gazelle.tm.NetworkCommunicationType']}"/>
                                                </ui:define>
                                                <h:outputText value="#{std.networkCommunicationType.label}"/>
                                            </g:column>

                                            <f:facet name="footer">
                                                <ui:include src="/util/datatableFooter.xhtml">
                                                    <ui:param name="dataScrollerId" value="dsImport"/>
                                                    <ui:param name="dataTableId" value="standardToImportTable"/>
                                                </ui:include>
                                            </f:facet>
                                        </rich:dataTable>
                                    </div>
                                </s:div>

                                <s:div rendered="#{standardManager.standardsToImport.duplicatedStandards != null and standardManager.reviewBeforeSaving}">
                                    <h:outputText value="#{standardManager.standardsToImport.duplicatedStandards.size} #{messages['net.ihe.gazelle.tm.StandardsAreAlreadyPresentInYourDatabaseAndWontB']}" style="font-weight:bold"/>
                                </s:div>
                                <s:div rendered="#{standardManager.standardsToImport.duplicatedStandards != null and not standardManager.reviewBeforeSaving}">
                                    <h:outputText value="#{standardManager.standardsToImport.duplicatedStandards.size} #{messages['net.ihe.gazelle.tm.StandardsHaveNotBeenImportedIntoYourDatabaseBeca']}" style="font-weight:bold"/>
                                </s:div>

                                <s:div rendered="#{not (standardManager.standardsToImport.duplicatedStandards == null) and not standardManager.standardsToImport.duplicatedStandards.isEmpty()}">
                                    <div class="panel-body">
                                        <rich:dataTable id="duplicateStandardsTable" var="std" value="#{standardManager.standardsToImport.duplicatedStandards}"
                                                        rowKeyVar="rowNumber" rows="#{dataScrollerMemory.numberOfResultsPerPage}" render="dsDuplicate">
                                            <g:column sortBy="#{'keyword'}">
                                                <ui:define name="header">
                                                    <h:outputText value="#{messages['gazelle.testmanagement.object.keyword']}"/>
                                                </ui:define>
                                                <h:outputText value="#{std.keyword}"/>
                                            </g:column>
                                            <g:column sortBy="#{'name'}">
                                                <ui:define name="header">
                                                    <h:outputText value="#{messages['gazelle.testmanagement.object.Name']}"/>
                                                </ui:define>
                                                <h:outputLink value="#{std.url}">
                                                    <h:outputText value="#{std.name}"/>
                                                </h:outputLink>
                                            </g:column>
                                            <g:column sortBy="#{'version'}">
                                                <ui:define name="header">
                                                    <h:outputText value="#{messages['gazelle.systems.system.SystemVersion']}"/>
                                                </ui:define>
                                                <h:outputText value="#{std.version}"/>
                                            </g:column>
                                            <g:column sortBy="#{'networkCommunicationType'}">
                                                <ui:define name="header">
                                                    <h:outputText value="#{messages['net.ihe.gazelle.tm.NetworkCommunicationType']}"/>
                                                </ui:define>
                                                <h:outputText value="#{std.networkCommunicationType.label}"/>
                                            </g:column>
                                            <f:facet name="footer">
                                                <ui:include src="/util/datatableFooter.xhtml">
                                                    <ui:param name="dataScrollerId" value="dsDuplicate"/>
                                                    <ui:param name="dataTableId" value="duplicateStandardsTable"/>
                                                </ui:include>
                                            </f:facet>
                                        </rich:dataTable>
                                    </div>
                                </s:div>
                            </s:div>
                            <ui:define name="panel_footer">
                                <s:div id="reportFooter">
                                    <a4j:commandButton styleClass="gzl-btn"
                                                       value="#{messages['net.ihe.gazelle.tm.Reset']}"
                                                       rendered="#{standardManager.getUploadedFileContent() != null}"
                                                       actionListener="#{standardManager.resetImport()}"
                                                       render="importDiv"
                                                       execute="@this"/>

                                    <a4j:commandButton value="#{messages['net.ihe.gazelle.tm.ImportStandards']}"
                                                       rendered="#{standardManager.getUploadedFileContent() != null and standardManager.reviewBeforeSaving and not standardManager.standardsToImport.isImported()}"
                                                       styleClass="gzl-btn-blue"
                                                       action="#{standardManager.persistImportedStandards()}"
                                                       render="standardTable,importDiv"/>
                                </s:div>
                            </ui:define>
                        </ui:decorate>
                    </s:div>


                    <ui:define name="panel_footer">
                        <s:div id="footer">
                            <a4j:commandButton styleClass="gzl-btn"
                                               value="#{messages['net.ihe.gazelle.tm.Reset']}"
                                               rendered="#{(standardManager.getUploadedFileContent() != null) and (standardManager.standardsToImport == null)}"
                                               actionListener="#{standardManager.resetUpload()}"
                                               render="importDiv"
                                               execute="@this"/>

                            <a4j:commandButton value="#{messages['net.ihe.gazelle.tm.ImportStandards']}"
                                               rendered="#{(standardManager.getUploadedFileContent() != null) and (standardManager.standardsToImport == null)}"
                                               styleClass="gzl-btn-blue"
                                               action="#{standardManager.importStandardsFromXml()}"
                                               render="standardTable,importDiv"/>
                        </s:div>
                    </ui:define>
                </ui:decorate>
            </s:div>

        </h:form>
        <h:form id="deleteDocumentForm">
            <s:token allowMultiplePosts="true"/>
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="DeleteConfirmationModalPanel"/>
                <ui:define name="popup_title">#{messages['net.ihe.gazelle.tm.PleaseConfirmDeleteOfTheAuditMessage']}</ui:define>
                <p>
                    <h:outputText value="#{messages['net.ihe.gazelle.tm.Standard']}"/>
                </p>
                <p>
                    <h:outputText value=" #{standardManager.selectedStandard.name} " style="font-weight:bold"/>
                </p>
                <p>
                    <h:outputText value="#{messages['net.ihe.gazelle.tm.WillBeDeleted']}"/>
                </p>
                <ui:define name="popup_footer">
                    <a4j:commandButton id="cancelButtonConfirm" value="#{messages['gazelle.common.button.Cancel']}"
                                       onclick="jq162('#DeleteConfirmationModalPanel').modal('hide');"
                                       styleClass="gzl-btn"
                                       actionListener="#{standardManager.setSelectedStandard(null)}"/>
                    <a4j:commandButton id="deleteButtonConfirm" value="#{messages['gazelle.common.button.Delete']}"
                                       ignoreDupResponses="true" styleClass="gzl-btn-red"
                                       actionListener="#{standardManager.delete()}"
                                       onclick="jq162('#DeleteConfirmationModalPanel').modal('hide');"
                                       render="globalform"/>
                </ui:define>
            </ui:decorate>
        </h:form>
    </ui:define>
</ui:composition>
